/* mbed Microcontroller Library
 * SPDX-License-Identifier: BSD-3-Clause
 ******************************************************************************
 *
 * Copyright (c) 2016-2021 STMicroelectronics.
 * All rights reserved.
 *
 * This software component is licensed by ST under BSD 3-Clause license,
 * the "License"; You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at:
 *                        opensource.org/licenses/BSD-3-Clause
 *
 ******************************************************************************
 *
 * Automatically generated from STM32CubeMX/db/mcu/STM32F411C(C-E)Ux.xml
 */

#ifndef MBED_PINNAMES_H
#define MBED_PINNAMES_H

#include "cmsis.h"
#include "platform/mbed_version.h"

#include "PinNamesTypes.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef enum {
    ALT0 = 0x100,
    ALT1 = 0x200,
    ALT2 = 0x300,
    ALT3 = 0x400,
    ALT4 = 0x500
} ALTx;

typedef enum {

    PA_0 = 0x00,
    PA_1 = 0x01,
    PA_2 = 0x02,
    PA_2_ALT0 = PA_2 | ALT0, // same pin used for alternate HW
    PA_3 = 0x03,
    PA_3_ALT0 = PA_3 | ALT0, // same pin used for alternate HW
    PA_4 = 0x04,
    PA_4_ALT0 = PA_4 | ALT0, // same pin used for alternate HW
    PA_5 = 0x05,
    PA_6 = 0x06,
    PA_7 = 0x07,
    PA_7_ALT0 = PA_7 | ALT0, // same pin used for alternate HW
    PA_8 = 0x08,
    PA_9 = 0x09,
    PA_10 = 0x0A,
    PA_11 = 0x0B,
    PA_12 = 0x0C,
    PA_13 = 0x0D,
    PA_14 = 0x0E,
    PA_15 = 0x0F,
    PA_15_ALT0 = PA_15 | ALT0, // same pin used for alternate HW
    PB_0 = 0x10,
    PB_0_ALT0 = PB_0 | ALT0, // same pin used for alternate HW
    PB_1 = 0x11,
    PB_1_ALT0 = PB_1 | ALT0, // same pin used for alternate HW
    PB_2 = 0x12,
    PB_3 = 0x13,
    PB_3_ALT0 = PB_3 | ALT0, // same pin used for alternate HW
    PB_4 = 0x14,
    PB_4_ALT0 = PB_4 | ALT0, // same pin used for alternate HW
    PB_5 = 0x15,
    PB_5_ALT0 = PB_5 | ALT0, // same pin used for alternate HW
    PB_6 = 0x16,
    PB_7 = 0x17,
    PB_8 = 0x18,
    PB_8_ALT0 = PB_8 | ALT0, // same pin used for alternate HW
    PB_9 = 0x19,
    PB_9_ALT0 = PB_9 | ALT0, // same pin used for alternate HW
    PB_10 = 0x1A,
    PB_12 = 0x1C,
    PB_12_ALT0 = PB_12 | ALT0, // same pin used for alternate HW
    PB_13 = 0x1D,
    PB_13_ALT0 = PB_13 | ALT0, // same pin used for alternate HW
    PB_14 = 0x1E,
    PB_15 = 0x1F,
    PC_13 = 0x2D,
    PC_14 = 0x2E,
    PC_15 = 0x2F,
    PH_0 = 0x70,
    PH_1 = 0x71,

    /**** ADC internal channels ****/

    ADC_TEMP = 0xF0, // Internal pin virtual value
    ADC_VREF = 0xF1, // Internal pin virtual value
    ADC_VBAT = 0xF2, // Internal pin virtual value

    // Arduino BluePill compatible pin name convention
    A0 = PA_0,
    A1 = PA_1,
    A2 = PA_4,
    A3 = PB_0,

    D0 = PA_3,
    D1 = PA_2,
    D2 = PA_10,
    D3 = PB_3,
    D4 = PB_5,
    D5 = PB_4,
    D6 = PB_10,
    D7 = PA_8,
    D8 = PA_9,

    D10 = PB_6,
    D11 = PA_7,
    D12 = PA_6,
    D13 = PA_5,
    D14 = PB_9,
    D15 = PB_8,

    // STDIO for console print
#ifdef MBED_CONF_TARGET_STDIO_UART_TX
    CONSOLE_TX = MBED_CONF_TARGET_STDIO_UART_TX,
#else
    CONSOLE_TX = PA_2,
#endif
#ifdef MBED_CONF_TARGET_STDIO_UART_RX
    CONSOLE_RX = MBED_CONF_TARGET_STDIO_UART_RX,
#else
    CONSOLE_RX = PA_3,
#endif

    // old STDIO pin names for backward compatibility
    STDIO_UART_TX = CONSOLE_TX,
    STDIO_UART_RX = CONSOLE_RX,

#if MBED_VERSION < MBED_ENCODE_VERSION(6, 10, 0)
    USBTX = CONSOLE_TX, // used for greentea tests
    USBRX = CONSOLE_RX, // used for greentea tests
#endif

    // I2C signals aliases
    I2C_SDA = PB_6,
    I2C_SCL = PB_7,

    // SPI signals aliases
    SPI_CS = PA_4,
    SPI_MOSI = PA_7,
    SPI_MISO = PA_6,
    SPI_SCK = PA_5,

    // Backward legacy names
    USER_BUTTON = PA_0,
    PWM_OUT = D3,

    /**** USB FS pins ****/
    USB_OTG_FS_DM = PA_11,
    USB_OTG_FS_DP = PA_12,
    USB_OTG_FS_ID = PA_10,
    USB_OTG_FS_SOF = PA_8,
    USB_OTG_FS_VBUS = PA_9,

    /**** OSCILLATOR pins ****/
    RCC_OSC32_IN = PC_14,
    RCC_OSC32_OUT = PC_15,
    RCC_OSC_IN = PH_0,
    RCC_OSC_OUT = PH_1,

    /**** DEBUG pins ****/
    SYS_JTCK_SWCLK = PA_14,
    SYS_JTDI = PA_15,
    SYS_JTDO_SWO = PB_3,
    SYS_JTMS_SWDIO = PA_13,
    SYS_JTRST = PB_4,
    SYS_WKUP = PA_0,

    // Not connected
    NC = (int)0xFFFFFFFF
} PinName;

// Standardized LED and button names
#define LED1     PC_13   // LD2 [Green Led]
#define BUTTON1  PA_0  // B1 [Blue PushButton]

#ifdef __cplusplus
}
#endif

#endif
